GNU Radio C++ API Reference: gr::uhd::usrp_block Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::uhd::usrp_block Class Referenceabstract
GNU Radio C++ Signal Processing Blocks » UHD Interface

`#include <gnuradio/uhd/usrp_block.h>`

## Public Member Functions
virtual void | set_subdev_spec (const std::string &spec, size_t mboard=0)=0
virtual std::string | get_subdev_spec (size_t mboard=0)=0
virtual size_t | get_num_mboards ()=0
virtual void | set_samp_rate (double rate)=0
virtual double | get_samp_rate (void)=0
virtual::uhd::meta_range_t | get_samp_rates (void)=0
virtual::uhd::tune_result_t | set_center_freq (const ::uhd::tune_request_t tune_request, size_t chan=0)=0
::uhd::tune_result_t | set_center_freq (double freq, size_t chan=0)
virtual double | get_center_freq (size_t chan=0)=0
virtual::uhd::freq_range_t | get_freq_range (size_t chan=0)=0
virtual void | set_gain (double gain, size_t chan=0, pmt::pmt_t direction=pmt::PMT_NIL)=0
virtual void | set_gain (double gain, const std::string &name, size_t chan=0)=0
virtual void | set_normalized_gain (double norm_gain, size_t chan=0)=0
virtual double | get_gain (size_t chan=0)=0
virtual double | get_gain (const std::string &name, size_t chan=0)=0
virtual double | get_normalized_gain (size_t chan=0)=0
virtual std::vector< std::string > | get_gain_names (size_t chan=0)=0
virtual::uhd::gain_range_t | get_gain_range (size_t chan=0)=0
virtual::uhd::gain_range_t | get_gain_range (const std::string &name, size_t chan=0)=0
virtual bool | has_power_reference (size_t chan=0)=0
virtual void | set_power_reference (double power_dbm, size_t chan=0)=0
virtual double | get_power_reference (size_t chan=0)=0
virtual::uhd::meta_range_t | get_power_range (size_t chan=0)=0
virtual void | set_antenna (const std::string &ant, size_t chan=0)=0
virtual std::string | get_antenna (size_t chan=0)=0
virtual std::vector< std::string > | get_antennas (size_t chan=0)=0
virtual void | set_bandwidth (double bandwidth, size_t chan=0)=0
virtual double | get_bandwidth (size_t chan=0)=0
virtual::uhd::freq_range_t | get_bandwidth_range (size_t chan=0)=0
virtual::uhd::sensor_value_t | get_sensor (const std::string &name, size_t chan=0)=0
virtual std::vector< std::string > | get_sensor_names (size_t chan=0)=0
::uhd::sensor_value_t | get_dboard_sensor (const std::string &name, size_t chan=0)
| DEPRECATED use get_sensor.
std::vector< std::string > | get_dboard_sensor_names (size_t chan=0)
| DEPRECATED use get_sensor_names.
virtual::uhd::sensor_value_t | get_mboard_sensor (const std::string &name, size_t mboard=0)=0
virtual std::vector< std::string > | get_mboard_sensor_names (size_t mboard=0)=0
virtual std::string | get_time_source (const size_t mboard)=0
virtual std::vector< std::string > | get_time_sources (const size_t mboard)=0
virtual void | set_clock_source (const std::string &source, const size_t mboard=0)=0
virtual std::string | get_clock_source (const size_t mboard)=0
virtual std::vector< std::string > | get_clock_sources (const size_t mboard)=0
virtual double | get_clock_rate (size_t mboard=0)=0
virtual void | set_clock_rate (double rate, size_t mboard=0)=0
virtual::uhd::time_spec_t | get_time_now (size_t mboard=0)=0
virtual::uhd::time_spec_t | get_time_last_pps (size_t mboard=0)=0
virtual void | set_time_now (const ::uhd::time_spec_t &time_spec, size_t mboard=0)=0
virtual void | set_time_next_pps (const ::uhd::time_spec_t &time_spec)=0
virtual void | set_time_unknown_pps (const ::uhd::time_spec_t &time_spec)=0
virtual void | set_command_time (const ::uhd::time_spec_t &time_spec, size_t mboard=0)=0
virtual void | clear_command_time (size_t mboard=0)=0
virtual::uhd::usrp::dboard_iface::sptr | get_dboard_iface (size_t chan=0)=0
virtual::uhd::usrp::multi_usrp::sptr | get_device (void)=0
virtual void | set_user_register (const uint8_t addr, const uint32_t data, size_t mboard=0)=0
virtual void | set_time_source (const std::string &source, const size_t mboard=0)=0
virtual void | set_stream_args (const ::uhd::stream_args_t &stream_args)=0
virtual std::vector< std::string > | get_gpio_banks (const size_t mboard)=0
virtual void | set_gpio_attr (const std::string &bank, const std::string &attr, const uint32_t value, const uint32_t mask=0xffffffff, const size_t mboard=0)=0
virtual uint32_t | get_gpio_attr (const std::string &bank, const std::string &attr, const size_t mboard=0)=0
virtual std::vector< std::string > | get_filter_names (const size_t chan=0)=0
virtual void | set_filter (const std::string &path, ::uhd::filter_info_base::sptr filter, const size_t chan=0)=0
virtual::uhd::filter_info_base::sptr | get_filter (const std::string &path, const size_t chan=0)=0
virtual ::uhd::dict< std::string, std::string > | get_usrp_info (size_t chan=0)=0
Public Member Functions inherited from gr::sync_block
virtual int | work (int noutput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items)=0
| just like gr::block::general_work, only this arranges to call consume_each for you
void | forecast (int noutput_items, gr_vector_int &ninput_items_required) override
| Estimate input requirements given output request.
int | general_work (int noutput_items, gr_vector_int &ninput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items) override
| compute output items from input items
int | fixed_rate_ninput_to_noutput (int ninput) override
| Given ninput samples, return number of output samples that will be produced. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
int | fixed_rate_noutput_to_ninput (int noutput) override
| Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
Public Member Functions inherited from gr::block
| ~block () override
unsigned | history () const
void | set_history (unsigned history)
void | declare_sample_delay (int which, unsigned delay)
void | declare_sample_delay (unsigned delay)
unsigned | sample_delay (int which) const
bool | fixed_rate () const
| Return true if this block has a fixed input to output rate.
virtual bool | start ()
| Called to enable drivers, etc for i/o devices.
virtual bool | stop ()
| Called to disable drivers, etc for i/o devices.
void | set_output_multiple (int multiple)
| Constrain the noutput_items argument passed to forecast and general_work.
int | output_multiple () const
bool | output_multiple_set () const
void | set_alignment (int multiple)
| Constrains buffers to work on a set item alignment (for SIMD).
int | alignment () const
void | set_unaligned (int na)
int | unaligned () const
void | set_is_unaligned (bool u)
bool | is_unaligned () const
void | consume (int which_input, int how_many_items)
| Tell the scheduler `how_many_items` of input stream `which_input` were consumed.
void | consume_each (int how_many_items)
| Tell the scheduler `how_many_items` were consumed on each input stream.
void | produce (int which_output, int how_many_items)
| Tell the scheduler `how_many_items` were produced on output stream `which_output`.
void | set_relative_rate (double relative_rate)
| Set the approximate output rate / input rate.
void | set_inverse_relative_rate (double inverse_relative_rate)
| Set the approximate output rate / input rate using its reciprocal.
void | set_relative_rate (uint64_t interpolation, uint64_t decimation)
| Set the approximate output rate / input rate as an integer ratio.
double | relative_rate () const
| return the approximate output rate / input rate
uint64_t | relative_rate_i () const
| return the numerator, or interpolation rate, of the approximate output rate / input rate
uint64_t | relative_rate_d () const
| return the denominator, or decimation rate, of the approximate output rate / input rate
mpq_class & | mp_relative_rate ()
| return a reference to the multiple precision rational representation of the approximate output rate / input rate
uint64_t | nitems_read (unsigned int which_input)
| Return the number of items read on input stream which_input.
uint64_t | nitems_written (unsigned int which_output)
| Return the number of items written on output stream which_output.
tag_propagation_policy_t | tag_propagation_policy ()
| Asks for the policy used by the scheduler to moved tags downstream.
void | set_tag_propagation_policy (tag_propagation_policy_t p)
| Set the policy by the scheduler to determine how tags are moved downstream.
int | min_noutput_items () const
| Return the minimum number of output items this block can produce during a call to work.
void | set_min_noutput_items (int m)
| Set the minimum number of output items this block can produce during a call to work.
int | max_noutput_items ()
| Return the maximum number of output items this block will handle during a call to work.
void | set_max_noutput_items (int m)
| Set the maximum number of output items this block will handle during a call to work.
void | unset_max_noutput_items ()
| Clear the switch for using the max_noutput_items value of this block.
bool | is_set_max_noutput_items ()
| Ask the block if the flag is or is not set to use the internal value of max_noutput_items during a call to work.
void | expand_minmax_buffer (int port)
long | max_output_buffer (size_t i)
| Returns max buffer size on output port `i`.
void | set_max_output_buffer (long max_output_buffer)
| Request limit on max buffer size on all output ports.
void | set_max_output_buffer (int port, long max_output_buffer)
| Request limit on max buffer size on output port `port`.
long | min_output_buffer (size_t i)
| Returns min buffer size on output port `i`.
void | set_min_output_buffer (long min_output_buffer)
| Request limit on the minimum buffer size on all output ports.
void | set_min_output_buffer (int port, long min_output_buffer)
| Request limit on min buffer size on output port `port`.
void | set_blkd_input_timer_value (unsigned int timer_value_ms)
| DEPRECATED Configure the timer set when input is blocked `port`.
unsigned int | blkd_input_timer_value ()
| DEPRECATED Returns timer value set when input is blocked.
void | allocate_detail (int ninputs, int noutputs, const std::vector< int > &downstream_max_nitems_vec, const std::vector< uint64_t > &downstream_lcm_nitems_vec, const std::vector< uint32_t > &downstream_max_out_mult_vec)
| Allocate the block_detail and necessary output buffers for this block.
buffer_sptr | replace_buffer (size_t src_port, size_t dst_port, block_sptr block_owner)
| Replace the block's buffer with a new one owned by the block_owner parameter.
float | pc_noutput_items ()
| Gets instantaneous noutput_items performance counter.
float | pc_noutput_items_avg ()
| Gets average noutput_items performance counter.
float | pc_noutput_items_var ()
| Gets variance of noutput_items performance counter.
float | pc_nproduced ()
| Gets instantaneous num items produced performance counter.
float | pc_nproduced_avg ()
| Gets average num items produced performance counter.
float | pc_nproduced_var ()
| Gets variance of num items produced performance counter.
float | pc_input_buffers_full (int which)
| Gets instantaneous fullness of `which` input buffer.
float | pc_input_buffers_full_avg (int which)
| Gets average fullness of `which` input buffer.
float | pc_input_buffers_full_var (int which)
| Gets variance of fullness of `which` input buffer.
std::vector< float > | pc_input_buffers_full ()
| Gets instantaneous fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_avg ()
| Gets average fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_var ()
| Gets variance of fullness of all input buffers.
float | pc_output_buffers_full (int which)
| Gets instantaneous fullness of `which` output buffer.
float | pc_output_buffers_full_avg (int which)
| Gets average fullness of `which` output buffer.
float | pc_output_buffers_full_var (int which)
| Gets variance of fullness of `which` output buffer.
std::vector< float > | pc_output_buffers_full ()
| Gets instantaneous fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_avg ()
| Gets average fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_var ()
| Gets variance of fullness of all output buffers.
float | pc_work_time ()
| Gets instantaneous clock cycles spent in work.
float | pc_work_time_avg ()
| Gets average clock cycles spent in work.
float | pc_work_time_var ()
| Gets average clock cycles spent in work.
float | pc_work_time_total ()
| Gets total clock cycles spent in work.
float | pc_throughput_avg ()
| Gets average throughput.
void | reset_perf_counters ()
| Resets the performance counters.
void | setup_pc_rpc ()
| Sets up export of perf. counters to ControlPort. Only called by the scheduler.
bool | is_pc_rpc_set () const
| Checks if this block is already exporting perf. counters to ControlPort.
void | no_pc_rpc ()
| If the block calls this in its constructor, it's perf. counters will not be exported.
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the thread's affinity to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity to a specific core.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
int | active_thread_priority ()
| Get the current thread priority in use.
int | thread_priority ()
| Get the current thread priority stored.
int | set_thread_priority (int priority)
| Set the current thread priority.
bool | update_rate () const
void | system_handler (pmt::pmt_t msg)
| the system message handler
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | finished ()
| returns true when execution has completed due to a message connection
block_detail_sptr | detail () const
void | set_detail (block_detail_sptr detail)
void | notify_msg_neighbors ()
| Tell msg neighbors we are finished.
void | clear_finished ()
| Make sure we don't think we are finished.
std::string | identifier () const
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
virtual bool | message_port_is_hier (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_in (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_out (pmt::pmt_t port_id)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
virtual bool | has_msg_port (pmt::pmt_t which_port)
const msg_queue_map_t & | get_msg_map (void) const
void | add_rpc_variable (rpcbasic_sptr s)
| Add an RPC variable (get or set).
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Protected Member Functions
| usrp_block ()
| usrp_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
Protected Member Functions inherited from gr::sync_block
| sync_block (void)
| sync_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
Protected Member Functions inherited from gr::block
| block (void)
| block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
void | set_fixed_rate (bool fixed_rate)
void | add_item_tag (unsigned int which_output, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| Adds a new tag onto the given output buffer.
void | add_item_tag (unsigned int which_output, const tag_t &tag)
| Adds a new tag onto the given output buffer.
void | remove_item_tag (unsigned int which_input, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| DEPRECATED. Will be removed in 3.8.
void | remove_item_tag (unsigned int which_input, const tag_t &tag)
| DEPRECATED. Will be removed in 3.8.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end)
| Given a [start,end), returns a vector of all tags in the range.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end, const pmt::pmt_t &key)
| Given a [start,end), returns a vector of all tags in the range with a given key.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end)
| Gets all tags within the relative window of the current call to work.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end, const pmt::pmt_t &key)
| Operates like gr::block::get_tags_in_window with the ability to only return tags with the specified `key`.
void | enable_update_rate (bool en)
buffer_sptr | allocate_buffer (size_t port, int downstream_max_nitems, uint64_t downstream_lcm_nitems, uint32_t downstream_max_out_mult)
| Allocate a buffer for the given output port of this block. Note that the downstream max number of items must be passed in to this function for consideration.
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.

## Additional Inherited Members
Public Types inherited from gr::block
enum | work_return_t { WORK_CALLED_PRODUCE = -2 , WORK_DONE = -1 }
| Magic return values from general_work. More...
enum | tag_propagation_policy_t { TPP_DONT = 0 , TPP_ALL_TO_ALL = 1 , TPP_ONE_TO_ONE = 2 , TPP_CUSTOM = 3 }
| enum to represent different tag propagation policies. More...
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }
Protected Attributes inherited from gr::block
std::vector< long > | d_max_output_buffer
std::vector< long > | d_min_output_buffer
unsigned int | d_blkd_input_timer_value = 250
gr::thread::mutex | d_setlock
const pmt::pmt_t | d_pmt_done
const pmt::pmt_t | d_system_port
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Detailed Description

Base class for USRP blocks.

Note that many of the functions defined here differ between Rx and Tx configurations. As an example, set_center_freq() will set the Rx frequency for a usrp_source object, and the Tx frequency on a usrp_sink object.

## Constructor & Destructor Documentation

## ◆ usrp_block() [1/2]

gr::uhd::usrp_block::usrp_block | ( |  | ) |
| inlineprotected

## ◆ usrp_block() [2/2]

gr::uhd::usrp_block::usrp_block | ( | const std::string & | name,
|  | gr::io_signature::sptr | input_signature,
|  | gr::io_signature::sptr | output_signature )
| protected

References gr::basic_block::input_signature(), gr::basic_block::name(), and gr::basic_block::output_signature().

## Member Function Documentation

## ◆ clear_command_time()

virtual void gr::uhd::usrp_block::clear_command_time | ( | size_t | mboard = 0 | ) |
| pure virtual

Clear the command time so future commands are sent ASAP.

Parameters

  mboard | which motherboard to set the config

## ◆ get_antenna()

virtual std::string gr::uhd::usrp_block::get_antenna | ( | size_t | chan = 0 | ) |
| pure virtual

Get the antenna in use.

Parameters

  chan | the channel index 0 to N-1

Returns
  the antenna string

## ◆ get_antennas()

virtual std::vector< std::string > gr::uhd::usrp_block::get_antennas | ( | size_t | chan = 0 | ) |
| pure virtual

Get a list of possible antennas on a given channel.

Parameters

  chan | the channel index 0 to N-1

Returns
  a vector of antenna strings

## ◆ get_bandwidth()

virtual double gr::uhd::usrp_block::get_bandwidth | ( | size_t | chan = 0 | ) |
| pure virtual

Get the bandpass filter setting on the RF frontend.

Parameters

  chan | the channel index 0 to N-1

Returns
  bandwidth of the filter in Hz

## ◆ get_bandwidth_range()

virtual::uhd::freq_range_t gr::uhd::usrp_block::get_bandwidth_range | ( | size_t | chan = 0 | ) |
| pure virtual

Get the bandpass filter range of the RF frontend.

Parameters

  chan | the channel index 0 to N-1

Returns
  the range of the filter bandwidth in Hz

## ◆ get_center_freq()

virtual double gr::uhd::usrp_block::get_center_freq | ( | size_t | chan = 0 | ) |
| pure virtual

Get the center frequency.

Parameters

  chan | the channel index 0 to N-1

Returns
  the frequency in Hz

## ◆ get_clock_rate()

virtual double gr::uhd::usrp_block::get_clock_rate | ( | size_t | mboard = 0 | ) |
| pure virtual

Get the master clock rate.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  the clock rate in Hz

## ◆ get_clock_source()

virtual std::string gr::uhd::usrp_block::get_clock_source | ( | const size_t | mboard | ) |
| pure virtual

Get the currently set clock source.

Parameters

  mboard | which motherboard to get the config

Returns
  the string representing the clock source

## ◆ get_clock_sources()

virtual std::vector< std::string > gr::uhd::usrp_block::get_clock_sources | ( | const size_t | mboard | ) |
| pure virtual

Get a list of possible clock sources.

Parameters

  mboard | which motherboard to get the list

Returns
  a vector of strings for possible settings

## ◆ get_dboard_iface()

virtual::uhd::usrp::dboard_iface::sptr gr::uhd::usrp_block::get_dboard_iface | ( | size_t | chan = 0 | ) |
| pure virtual

Get access to the underlying uhd dboard iface object.

Returns
  the dboard_iface object

## ◆ get_dboard_sensor()

::uhd::sensor_value_t gr::uhd::usrp_block::get_dboard_sensor | ( | const std::string & | name,
|  | size_t | chan = 0 )
| inline

DEPRECATED use get_sensor.

References get_sensor(), and gr::basic_block::name().

## ◆ get_dboard_sensor_names()

std::vector< std::string > gr::uhd::usrp_block::get_dboard_sensor_names | ( | size_t | chan = 0 | ) |
| inline

DEPRECATED use get_sensor_names.

References get_sensor_names().

## ◆ get_device()

virtual::uhd::usrp::multi_usrp::sptr gr::uhd::usrp_block::get_device | ( | void |  | ) |
| pure virtual

Get access to the underlying uhd device object.

NOTE: This function is only available in C++.

Returns
  the multi usrp device object

## ◆ get_filter()

virtual::uhd::filter_info_base::sptr gr::uhd::usrp_block::get_filter | ( | const std::string & | path,
|  | const size_t | chan = 0 )
| pure virtual

Return the filter object for the given name.

Parameters

  path | the name of the filter as returned from get_filter_names()
  chan | Channel index

Returns
  the filter object

## ◆ get_filter_names()

virtual std::vector< std::string > gr::uhd::usrp_block::get_filter_names | ( | const size_t | chan = 0 | ) |
| pure virtual

Enumerate the available filters in the signal path.

Parameters

  chan | Channel index

Returns
  a vector of strings representing the selected filter names.

## ◆ get_freq_range()

virtual::uhd::freq_range_t gr::uhd::usrp_block::get_freq_range | ( | size_t | chan = 0 | ) |
| pure virtual

Get the tunable frequency range.

Parameters

  chan | the channel index 0 to N-1

Returns
  the frequency range in Hz

## ◆ get_gain() [1/2]

virtual double gr::uhd::usrp_block::get_gain | ( | const std::string & | name,
|  | size_t | chan = 0 )
| pure virtual

Get the actual dboard gain setting of named stage.

Parameters

  name | the name of the gain stage
  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

References gr::basic_block::name().

## ◆ get_gain() [2/2]

virtual double gr::uhd::usrp_block::get_gain | ( | size_t | chan = 0 | ) |
| pure virtual

Get the actual dboard gain setting.

Parameters

  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

## ◆ get_gain_names()

virtual std::vector< std::string > gr::uhd::usrp_block::get_gain_names | ( | size_t | chan = 0 | ) |
| pure virtual

Get the actual dboard gain setting of named stage.

Parameters

  chan | the channel index 0 to N-1

Returns
  the actual gain in dB

## ◆ get_gain_range() [1/2]

virtual::uhd::gain_range_t gr::uhd::usrp_block::get_gain_range | ( | const std::string & | name,
|  | size_t | chan = 0 )
| pure virtual

Get the settable gain range.

Parameters

  name | the name of the gain stage
  chan | the channel index 0 to N-1

Returns
  the gain range in dB

References gr::basic_block::name().

## ◆ get_gain_range() [2/2]

virtual::uhd::gain_range_t gr::uhd::usrp_block::get_gain_range | ( | size_t | chan = 0 | ) |
| pure virtual

Get the settable gain range.

Parameters

  chan | the channel index 0 to N-1

Returns
  the gain range in dB

## ◆ get_gpio_attr()

virtual uint32_t gr::uhd::usrp_block::get_gpio_attr | ( | const std::string & | bank,
|  | const std::string & | attr,
|  | const size_t | mboard = 0 )
| pure virtual

Get a GPIO attribute on a particular GPIO bank. Possible attribute names:

- CTRL - 1 for ATR mode 0 for GPIO mode
- DDR - 1 for output 0 for input
- OUT - GPIO output level (not ATR mode)
- ATR_0X - ATR idle state
- ATR_RX - ATR receive only state
- ATR_TX - ATR transmit only state
- ATR_XX - ATR full duplex state
- READBACK - readback input GPIOs
  Parameters

    bank | the name of a GPIO bank
    attr | the name of a GPIO attribute
    mboard | the motherboard index 0 to M-1

  Returns
    the value set for this attribute

## ◆ get_gpio_banks()

virtual std::vector< std::string > gr::uhd::usrp_block::get_gpio_banks | ( | const size_t | mboard | ) |
| pure virtual

Enumerate GPIO banks on the current device.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  a list of string for each bank name

## ◆ get_mboard_sensor()

virtual::uhd::sensor_value_t gr::uhd::usrp_block::get_mboard_sensor | ( | const std::string & | name,
|  | size_t | mboard = 0 )
| pure virtual

Get a motherboard sensor value.

Parameters

  name | the name of the sensor
  mboard | the motherboard index 0 to M-1

Returns
  a sensor value object

References gr::basic_block::name().

## ◆ get_mboard_sensor_names()

virtual std::vector< std::string > gr::uhd::usrp_block::get_mboard_sensor_names | ( | size_t | mboard = 0 | ) |
| pure virtual

Get a list of possible motherboard sensor names.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  a vector of sensor names

## ◆ get_normalized_gain()

virtual double gr::uhd::usrp_block::get_normalized_gain | ( | size_t | chan = 0 | ) |
| pure virtual

Returns the normalized gain.

The normalized gain is always in [0, 1], regardless of the device. See also set_normalized_gain().

Note that it is not possible to specify a gain name for this function, the result is over the entire gain chain.

Parameters

  chan | the channel index 0 to N-1

## ◆ get_num_mboards()

virtual size_t gr::uhd::usrp_block::get_num_mboards | ( |  | ) |
| pure virtual

Return the number of motherboards in this configuration.

## ◆ get_power_range()

virtual::uhd::meta_range_t gr::uhd::usrp_block::get_power_range | ( | size_t | chan = 0 | ) |
| pure virtual

Return the available power range

Parameters

  chan | the channel index 0 to N-1

Returns
  the power range in dBm

Exceptions

  std::runtime_error | if the underlying UHD version does not support the power API.

## ◆ get_power_reference()

virtual double gr::uhd::usrp_block::get_power_reference | ( | size_t | chan = 0 | ) |
| pure virtual

Return the absolute power reference level for this channel

Note that this API is only available for certain devices, and assuming the existence of calibration data. Refer to the UHD manual for greater detail: https://files.ettus.com/manual/page_compat.html

See also set_power_reference().

Parameters

  chan | the channel index 0 to N-1

Exceptions

  std::runtime_error | if the underlying UHD version does not support the power API.

## ◆ get_samp_rate()

virtual double gr::uhd::usrp_block::get_samp_rate | ( | void |  | ) |
| pure virtual

Get the sample rate for this connection to the USRP. This is the actual sample rate and may differ from the rate set.

Returns
  the actual rate in Sps

## ◆ get_samp_rates()

virtual::uhd::meta_range_t gr::uhd::usrp_block::get_samp_rates | ( | void |  | ) |
| pure virtual

Get the possible sample rates for this connection.

Returns
  a range of rates in Sps

## ◆ get_sensor()

virtual::uhd::sensor_value_t gr::uhd::usrp_block::get_sensor | ( | const std::string & | name,
|  | size_t | chan = 0 )
| pure virtual

Get an RF frontend sensor value.

Parameters

  name | the name of the sensor
  chan | the channel index 0 to N-1

Returns
  a sensor value object

References gr::basic_block::name().

Referenced by get_dboard_sensor().

## ◆ get_sensor_names()

virtual std::vector< std::string > gr::uhd::usrp_block::get_sensor_names | ( | size_t | chan = 0 | ) |
| pure virtual

Get a list of possible RF frontend sensor names.

Parameters

  chan | the channel index 0 to N-1

Returns
  a vector of sensor names

Referenced by get_dboard_sensor_names().

## ◆ get_subdev_spec()

virtual std::string gr::uhd::usrp_block::get_subdev_spec | ( | size_t | mboard = 0 | ) |
| pure virtual

Get the frontend specification.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  the frontend specification in use

## ◆ get_time_last_pps()

virtual::uhd::time_spec_t gr::uhd::usrp_block::get_time_last_pps | ( | size_t | mboard = 0 | ) |
| pure virtual

Get the time when the last pps pulse occurred.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  the current usrp time

## ◆ get_time_now()

virtual::uhd::time_spec_t gr::uhd::usrp_block::get_time_now | ( | size_t | mboard = 0 | ) |
| pure virtual

Get the current time registers.

Parameters

  mboard | the motherboard index 0 to M-1

Returns
  the current usrp time

## ◆ get_time_source()

virtual std::string gr::uhd::usrp_block::get_time_source | ( | const size_t | mboard | ) |
| pure virtual

Get the currently set time source.

Parameters

  mboard | which motherboard to get the config

Returns
  the string representing the time source

## ◆ get_time_sources()

virtual std::vector< std::string > gr::uhd::usrp_block::get_time_sources | ( | const size_t | mboard | ) |
| pure virtual

Get a list of possible time sources.

Parameters

  mboard | which motherboard to get the list

Returns
  a vector of strings for possible settings

## ◆ get_usrp_info()

virtual ::uhd::dict< std::string, std::string > gr::uhd::usrp_block::get_usrp_info | ( | size_t | chan = 0 | ) |
| pure virtual

Returns identifying information about this USRP's configuration. Returns motherboard ID, name, and serial. Returns daughterboard TX ID, subdev name and spec, serial, and antenna.

Parameters

  chan | channel index 0 to N-1

Returns
  TX info

## ◆ has_power_reference()

virtual bool gr::uhd::usrp_block::has_power_reference | ( | size_t | chan = 0 | ) |
| pure virtual

Query if this device is capable of absolute power levels

If true, the set_power_reference() and get_power_reference() APIs can be used as well. Note that if the underlying UHD version doesn't support power APIs, a warning will be printed, and the return value is always false.

Parameters

  chan | the channel index 0 to N-1

Returns
  true if there is a power reference API available for this channel

## ◆ set_antenna()

virtual void gr::uhd::usrp_block::set_antenna | ( | const std::string & | ant,
|  | size_t | chan = 0 )
| pure virtual

Set the antenna to use for a given channel.

Parameters

  ant | the antenna string
  chan | the channel index 0 to N-1

## ◆ set_bandwidth()

virtual void gr::uhd::usrp_block::set_bandwidth | ( | double | bandwidth,
|  | size_t | chan = 0 )
| pure virtual

Set the bandpass filter on the RF frontend.

Parameters

  bandwidth | the filter bandwidth in Hz
  chan | the channel index 0 to N-1

## ◆ set_center_freq() [1/2]

virtual::uhd::tune_result_t gr::uhd::usrp_block::set_center_freq | ( | const ::uhd::tune_request_t | tune_request,
|  | size_t | chan = 0 )
| pure virtual

Tune the selected channel to the desired center frequency.

Parameters

  tune_request | the tune request instructions
  chan | the channel index 0 to N-1

Returns
  a tune result with the actual frequencies

Referenced by set_center_freq().

## ◆ set_center_freq() [2/2]

::uhd::tune_result_t gr::uhd::usrp_block::set_center_freq | ( | double | freq,
|  | size_t | chan = 0 )
| inline

Tune the selected channel to the desired center frequency.

This is a wrapper around set_center_freq() so that in this case, the user can pass a single frequency in the call instead of having to generate a tune_request_t object.

Parameters

  freq | the desired frequency in Hz
  chan | the channel index 0 to N-1

Returns
  a tune result with the actual frequencies

References set_center_freq().

## ◆ set_clock_rate()

virtual void gr::uhd::usrp_block::set_clock_rate | ( | double | rate,
|  | size_t | mboard = 0 )
| pure virtual

Set the master clock rate.

Parameters

  rate | the new rate in Hz
  mboard | the motherboard index 0 to M-1

## ◆ set_clock_source()

virtual void gr::uhd::usrp_block::set_clock_source | ( | const std::string & | source,
|  | const size_t | mboard = 0 )
| pure virtual

Set the clock source for the usrp device.

This sets the source for a 10 MHz reference clock. Typical options for source: internal, external, MIMO.

Parameters

  source | a string representing the clock source
  mboard | which motherboard to set the config

## ◆ set_command_time()

virtual void gr::uhd::usrp_block::set_command_time | ( | const ::uhd::time_spec_t & | time_spec,
|  | size_t | mboard = 0 )
| pure virtual

Set the time at which the control commands will take effect.

A timed command will back-pressure all subsequent timed commands, assuming that the subsequent commands occur within the time-window. If the time spec is late, the command will be activated upon arrival.

Parameters

  time_spec | the time at which the next command will activate
  mboard | which motherboard to set the config

## ◆ set_filter()

virtual void gr::uhd::usrp_block::set_filter | ( | const std::string & | path,
|  | ::uhd::filter_info_base::sptr | filter,
|  | const size_t | chan = 0 )
| pure virtual

Write back a filter obtained by get_filter() to the signal path.

This filter can be a modified version of the originally returned one. The information about Rx or Tx is contained in the path parameter.

Parameters

  path | the name of the filter as returned from get_filter_names().
  filter | the filter_info_base::sptr of the filter object to be written
  chan | Channel index

## ◆ set_gain() [1/2]

virtual void gr::uhd::usrp_block::set_gain | ( | double | gain,
|  | const std::string & | name,
|  | size_t | chan = 0 )
| pure virtual

Set the named gain on the dboard.

Parameters

  gain | the gain in dB
  name | the name of the gain stage
  chan | the channel index 0 to N-1

References gr::basic_block::name().

## ◆ set_gain() [2/2]

virtual void gr::uhd::usrp_block::set_gain | ( | double | gain,
|  | size_t | chan = 0,
|  | pmt::pmt_t | direction = pmt::PMT_NIL )
| pure virtual

Set the gain for the selected channel.

Parameters

  gain | the gain in dB
  chan | the channel index 0 to N-1
  direction | TX or RX. This is mostly used by the internal message handling.

## ◆ set_gpio_attr()

virtual void gr::uhd::usrp_block::set_gpio_attr | ( | const std::string & | bank,
|  | const std::string & | attr,
|  | const uint32_t | value,
|  | const uint32_t | mask = 0xffffffff,
|  | const size_t | mboard = 0 )
| pure virtual

Set a GPIO attribute on a particular GPIO bank. Possible attribute names:

- CTRL - 1 for ATR mode 0 for GPIO mode
- DDR - 1 for output 0 for input
- OUT - GPIO output level (not ATR mode)
- ATR_0X - ATR idle state
- ATR_RX - ATR receive only state
- ATR_TX - ATR transmit only state
- ATR_XX - ATR full duplex state
  Parameters

    bank | the name of a GPIO bank
    attr | the name of a GPIO attribute
    value | the new value for this GPIO bank
    mask | the bit mask to effect which pins are changed
    mboard | the motherboard index 0 to M-1

## ◆ set_normalized_gain()

virtual void gr::uhd::usrp_block::set_normalized_gain | ( | double | norm_gain,
|  | size_t | chan = 0 )
| pure virtual

Set the normalized gain.

The normalized gain is always in [0, 1], regardless of the device. 0 corresponds to minimum gain (usually 0 dB, but make sure to read the device notes in the UHD manual) and 1 corresponds to maximum gain. This will work for any UHD device. Use get_gain() to see which dB value the normalized gain value corresponds to.

Note that it is not possible to specify a gain name for this function.

Exceptions

  A | runtime_error if `norm_gain` is not within the valid range.

Parameters

  norm_gain | the gain in fractions of the gain range (must be 0 <= norm_gain <= 1)
  chan | the channel index 0 to N-1

## ◆ set_power_reference()

virtual void gr::uhd::usrp_block::set_power_reference | ( | double | power_dbm,
|  | size_t | chan = 0 )
| pure virtual

Set the absolute power reference level for this channel

Note that this API is available for certain devices only, and only if calibration data is available. Refer to the UHD manual for greater detail: https://files.ettus.com/manual/page_power.html

In a nutshell, using the power reference will configure the device such that a full-scale signal (0 dBFS) corresponds to a signal at the antenna connector of `power_dbm`. After calling this function, the device will attempt to keep the power level constant after retuning, which means the gain level may be changed after a re-tune.

The device may coerce the available power level (for example, if the requested power level is not achievable by the device). The coerced value may be read by calling get_power_reference().

Parameters

  power_dbm | The power reference level in dBm
  chan | the channel index 0 to N-1

Exceptions

  std::runtime_error | if the underlying UHD version does not support the power API.

## ◆ set_samp_rate()

virtual void gr::uhd::usrp_block::set_samp_rate | ( | double | rate | ) |
| pure virtual

Set the sample rate for this connection to the USRP.

Parameters

  rate | a new rate in Sps

## ◆ set_stream_args()

virtual void gr::uhd::usrp_block::set_stream_args | ( | const ::uhd::stream_args_t & | stream_args | ) |
| pure virtual

Update the stream args for this device.

This update will only take effect after a restart of the streaming, or before streaming and after construction. This will also delete the current streamer. Note you cannot change the I/O signature of this block using this function, or it will throw.

It is possible to leave the 'channels' fields of `stream_args` unset. In this case, the previous channels field is used.

Parameters

  stream_args | New stream args.

Exceptions

  std::runtime_error | if new settings are invalid.

## ◆ set_subdev_spec()

virtual void gr::uhd::usrp_block::set_subdev_spec | ( | const std::string & | spec,
|  | size_t | mboard = 0 )
| pure virtual

Set the frontend specification.

Parameters

  spec | the subdev spec markup string
  mboard | the motherboard index 0 to M-1

## ◆ set_time_next_pps()

virtual void gr::uhd::usrp_block::set_time_next_pps | ( | const ::uhd::time_spec_t & | time_spec | ) |
| pure virtual

Set the time registers at the next pps.

Parameters

  time_spec | the new time

## ◆ set_time_now()

virtual void gr::uhd::usrp_block::set_time_now | ( | const ::uhd::time_spec_t & | time_spec,
|  | size_t | mboard = 0 )
| pure virtual

Sets the time registers immediately.

Parameters

  time_spec | the new time
  mboard | the motherboard index 0 to M-1

## ◆ set_time_source()

virtual void gr::uhd::usrp_block::set_time_source | ( | const std::string & | source,
|  | const size_t | mboard = 0 )
| pure virtual

Set the time source for the USRP device.

This sets the method of time synchronization, typically a pulse per second or an encoded time. Typical options for source: external, MIMO.

Parameters

  source | a string representing the time source
  mboard | which motherboard to set the config

## ◆ set_time_unknown_pps()

virtual void gr::uhd::usrp_block::set_time_unknown_pps | ( | const ::uhd::time_spec_t & | time_spec | ) |
| pure virtual

Sync the time registers with an unknown pps edge.

Parameters

  time_spec | the new time

## ◆ set_user_register()

virtual void gr::uhd::usrp_block::set_user_register | ( | const uint8_t | addr,
|  | const uint32_t | data,
|  | size_t | mboard = 0 )
| pure virtual

Perform write on the user configuration register bus. These only exist if the user has implemented custom setting registers in the device FPGA.

Parameters

  addr | 8-bit register address
  data | 32-bit register value
  mboard | which motherboard to set the user register

The documentation for this class was generated from the following file:

- usrp_block.h